##// END OF EJS Templates
better apt-chacher-ng detection and correction apt_proxy
Unknown -
r433:03c791dae5ae
parent child
Show More
@@ -1,811 +1,812
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 #BIS= Kernel has KVM and zswap enabled
60 60 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
61 61 #default bcmrpi3_defconfig target kernel
62 62 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
63 63 #enhanced kernel
64 64 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_BIS_KERNEL_URL}
65 65 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
66 66
67 67 # Build directories
68 68 WORKDIR=$(pwd)
69 69 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
70 70 BUILDDIR="${BASEDIR}/build"
71 71
72 72 # Chroot directories
73 73 R="${BUILDDIR}/chroot"
74 74 ETC_DIR="${R}/etc"
75 75 LIB_DIR="${R}/lib"
76 76 BOOT_DIR="${R}/boot/firmware"
77 77 KERNEL_DIR="${R}/usr/src/linux"
78 78 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
79 79
80 80 # Firmware directory: Blank if download from github
81 81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82 82
83 83 # General settings
84 84 SET_ARCH=${SET_ARCH:=32}
85 85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
86 86 PASSWORD=${PASSWORD:=raspberry}
87 87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
88 88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
89 89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
90 90 EXPANDROOT=${EXPANDROOT:=true}
91 91
92 92 # Keyboard settings
93 93 XKB_MODEL=${XKB_MODEL:=""}
94 94 XKB_LAYOUT=${XKB_LAYOUT:=""}
95 95 XKB_VARIANT=${XKB_VARIANT:=""}
96 96 XKB_OPTIONS=${XKB_OPTIONS:=""}
97 97
98 98 # Network settings (DHCP)
99 99 ENABLE_DHCP=${ENABLE_DHCP:=true}
100 100
101 101 # Network settings (static)
102 102 NET_ADDRESS=${NET_ADDRESS:=""}
103 103 NET_GATEWAY=${NET_GATEWAY:=""}
104 104 NET_DNS_1=${NET_DNS_1:=""}
105 105 NET_DNS_2=${NET_DNS_2:=""}
106 106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
107 107 NET_NTP_1=${NET_NTP_1:=""}
108 108 NET_NTP_2=${NET_NTP_2:=""}
109 109
110 110 # APT settings
111 111 APT_PROXY=${APT_PROXY:=""}
112 112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
113 113
114 114 # Feature settings
115 115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
116 116 ENABLE_I2C=${ENABLE_I2C:=false}
117 117 ENABLE_SPI=${ENABLE_SPI:=false}
118 118 ENABLE_IPV6=${ENABLE_IPV6:=true}
119 119 ENABLE_SSHD=${ENABLE_SSHD:=true}
120 120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
121 121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
122 122 ENABLE_SOUND=${ENABLE_SOUND:=true}
123 123 ENABLE_DBUS=${ENABLE_DBUS:=true}
124 124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
125 125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
126 126 ENABLE_XORG=${ENABLE_XORG:=false}
127 127 ENABLE_WM=${ENABLE_WM:=""}
128 128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
129 129 ENABLE_USER=${ENABLE_USER:=true}
130 130 USER_NAME=${USER_NAME:="pi"}
131 131 ENABLE_ROOT=${ENABLE_ROOT:=false}
132 132 ENABLE_QEMU=${ENABLE_QEMU:=false}
133 133 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
134 134
135 135 # SSH settings
136 136 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
137 137 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
138 138 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
139 139 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
140 140 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
141 141
142 142 # Advanced settings
143 143 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
144 144 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
145 145 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
146 146 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
147 147 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
148 148 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
149 149 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
150 150 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
151 151 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
152 152 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
153 153 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
154 154 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
155 155 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
156 156 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
157 157 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
158 158
159 159 # Kernel compilation settings
160 160 BUILD_KERNEL=${BUILD_KERNEL:=true}
161 161 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
162 162 KERNEL_THREADS=${KERNEL_THREADS:=1}
163 163 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
164 164 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
165 165 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
166 166 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
167 167 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
168 168 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
169 169 KERNEL_VIRT=${KERNEL_VIRT:=false}
170 170 KERNEL_BPF=${KERNEL_BPF:=false}
171 171
172 172 # Kernel compilation from source directory settings
173 173 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
174 174 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
175 175 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
176 176 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
177 177
178 178 # Reduce disk usage settings
179 179 REDUCE_APT=${REDUCE_APT:=true}
180 180 REDUCE_DOC=${REDUCE_DOC:=true}
181 181 REDUCE_MAN=${REDUCE_MAN:=true}
182 182 REDUCE_VIM=${REDUCE_VIM:=false}
183 183 REDUCE_BASH=${REDUCE_BASH:=false}
184 184 REDUCE_HWDB=${REDUCE_HWDB:=true}
185 185 REDUCE_SSHD=${REDUCE_SSHD:=true}
186 186 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
187 187
188 188 # Encrypted filesystem settings
189 189 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
190 190 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
191 191 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
192 192 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
193 193 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
194 194
195 195 # Chroot scripts directory
196 196 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
197 197
198 198 # Packages required in the chroot build environment
199 199 APT_INCLUDES=${APT_INCLUDES:=""}
200 200 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
201 201
202 202 #Packages to exclude from chroot build environment
203 203 APT_EXCLUDES=${APT_EXCLUDES:=""}
204 204
205 205 # Packages required for bootstrapping
206 206 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
207 207 MISSING_PACKAGES=""
208 208
209 209 # Packages installed for c/c++ build environment in chroot (keep empty)
210 210 COMPILER_PACKAGES=""
211 211
212 #Check if apt-cacher-ng has its default port open on and set APT_PROXY
213 if [ -n "$(lsof -i :3142)" ] ; then
214 HTTP_PROXY=http://127.0.0.1:3142/
212 #Check if apt-cacher-ng has port 3142 open and set APT_PROXY
213 APT_CACHER_RUNNING=$(lsof -i :3142 | grep apt-cacher-ng | cut -d ' ' -f3 | uniq)
214 if [ -n ${APT_CACHER_RUNNING} ] ; then
215 APT_PROXY=http://127.0.0.1:3142/
215 216 fi
216 217
217 218 #netselect-apt does not know buster yet
218 219 if [ "$RELEASE" = "buster" ] ; then
219 220 RLS=testing
220 221 else
221 222 RLS="$RELEASE"
222 223 fi
223 224
224 225 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
225 226 rm "$(pwd)/files/apt/sources.list"
226 227 fi
227 228
228 229 if [ "$ENABLE_NONFREE" = true ] ; then
229 230 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
230 231 else
231 232 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
232 233 fi
233 234
234 235 #sed and cut the result string so we can use it as APT_SERVER
235 236 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
236 237
237 238 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
238 239 if [ -n "$SET_ARCH" ] ; then
239 240 # 64 bit configuration
240 241 if [ "$SET_ARCH" = 64 ] ; then
241 242 # General 64 bit depended settings
242 243 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
243 244 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
244 245 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
245 246
246 247 # Board specific settings
247 248 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
248 249 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
249 250 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
250 251 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
251 252 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
252 253 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
253 254 else
254 255 echo "error: Only Raspberry PI 3 and 3B+ support 64 bit"
255 256 exit 1
256 257 fi
257 258 fi
258 259
259 260 # 32 bit configuration
260 261 if [ "$SET_ARCH" = 32 ] ; then
261 262 # General 32 bit dependend settings
262 263 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
263 264 KERNEL_ARCH=${KERNEL_ARCH:=arm}
264 265 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
265 266
266 267 # Hardware specific settings
267 268 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
268 269 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
269 270 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
270 271 RELEASE_ARCH=${RELEASE_ARCH:=armel}
271 272 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
272 273 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
273 274 fi
274 275
275 276 # Hardware specific settings
276 277 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
277 278 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
278 279 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
279 280 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
280 281 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
281 282 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
282 283 fi
283 284 fi
284 285 #SET_ARCH not set
285 286 else
286 287 echo "error: Please set '32' or '64' as value for SET_ARCH"
287 288 exit 1
288 289 fi
289 290 # Device specific configuration and U-Boot configuration
290 291 case "$RPI_MODEL" in
291 292 0)
292 293 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
293 294 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
294 295 ;;
295 296 1)
296 297 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
297 298 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
298 299 ;;
299 300 1P)
300 301 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
301 302 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
302 303 ;;
303 304 2)
304 305 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
305 306 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
306 307 ;;
307 308 3)
308 309 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
309 310 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
310 311 ;;
311 312 3P)
312 313 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
313 314 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
314 315 ;;
315 316 *)
316 317 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
317 318 exit 1
318 319 ;;
319 320 esac
320 321
321 322 # Prepare date string for default image file name
322 323 DATE="$(date +%Y-%m-%d)"
323 324 if [ -z "$KERNEL_BRANCH" ] ; then
324 325 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
325 326 else
326 327 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
327 328 fi
328 329
329 330 # Check if the internal wireless interface is supported by the RPi model
330 331 if [ "$ENABLE_WIRELESS" = true ] ; then
331 332 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
332 333 echo "error: The selected Raspberry Pi model has no internal wireless interface"
333 334 exit 1
334 335 fi
335 336 fi
336 337
337 338 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
338 339 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
339 340 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
340 341 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
341 342 exit 1
342 343 fi
343 344 fi
344 345
345 346 # Add cmake to compile videocore sources
346 347 if [ "$ENABLE_VIDEOCORE" = true ] ; then
347 348 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
348 349 fi
349 350
350 351 # Add libncurses5 to enable kernel menuconfig
351 352 if [ "$KERNEL_MENUCONFIG" = true ] ; then
352 353 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
353 354 fi
354 355
355 356 # Add ccache compiler cache for (faster) kernel cross (re)compilation
356 357 if [ "$KERNEL_CCACHE" = true ] ; then
357 358 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
358 359 fi
359 360
360 361 # Add cryptsetup package to enable filesystem encryption
361 362 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
362 363 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
363 364 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
364 365
365 366 if [ -z "$CRYPTFS_PASSWORD" ] ; then
366 367 echo "error: no password defined (CRYPTFS_PASSWORD)!"
367 368 exit 1
368 369 fi
369 370 ENABLE_INITRAMFS=true
370 371 fi
371 372
372 373 # Add initramfs generation tools
373 374 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
374 375 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
375 376 fi
376 377
377 378 # Add device-tree-compiler required for building the U-Boot bootloader
378 379 if [ "$ENABLE_UBOOT" = true ] ; then
379 380 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
380 381 else
381 382 if [ "$ENABLE_UBOOTUSB" = true ] ; then
382 383 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
383 384 exit 1
384 385 fi
385 386 fi
386 387
387 388 # Check if root SSH (v2) public key file exists
388 389 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
389 390 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
390 391 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
391 392 exit 1
392 393 fi
393 394 fi
394 395
395 396 # Check if $USER_NAME SSH (v2) public key file exists
396 397 if [ -n "$SSH_USER_PUB_KEY" ] ; then
397 398 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
398 399 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
399 400 exit 1
400 401 fi
401 402 fi
402 403
403 404 # Check if all required packages are installed on the build system
404 405 for package in $REQUIRED_PACKAGES ; do
405 406 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
406 407 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
407 408 fi
408 409 done
409 410
410 411 # If there are missing packages ask confirmation for install, or exit
411 412 if [ -n "$MISSING_PACKAGES" ] ; then
412 413 echo "the following packages needed by this script are not installed:"
413 414 echo "$MISSING_PACKAGES"
414 415
415 416 printf "\ndo you want to install the missing packages right now? [y/n] "
416 417 read -r confirm
417 418 [ "$confirm" != "y" ] && exit 1
418 419
419 420 # Make sure all missing required packages are installed
420 421 apt-get -qq -y install "${MISSING_PACKAGES}"
421 422 fi
422 423
423 424 # Check if ./bootstrap.d directory exists
424 425 if [ ! -d "./bootstrap.d/" ] ; then
425 426 echo "error: './bootstrap.d' required directory not found!"
426 427 exit 1
427 428 fi
428 429
429 430 # Check if ./files directory exists
430 431 if [ ! -d "./files/" ] ; then
431 432 echo "error: './files' required directory not found!"
432 433 exit 1
433 434 fi
434 435
435 436 # Check if specified KERNELSRC_DIR directory exists
436 437 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
437 438 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
438 439 exit 1
439 440 fi
440 441
441 442 # Check if specified UBOOTSRC_DIR directory exists
442 443 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
443 444 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
444 445 exit 1
445 446 fi
446 447
447 448 # Check if specified VIDEOCORESRC_DIR directory exists
448 449 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
449 450 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
450 451 exit 1
451 452 fi
452 453
453 454 # Check if specified FBTURBOSRC_DIR directory exists
454 455 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
455 456 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
456 457 exit 1
457 458 fi
458 459
459 460 # Check if specified CHROOT_SCRIPTS directory exists
460 461 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
461 462 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
462 463 exit 1
463 464 fi
464 465
465 466 # Check if specified device mapping already exists (will be used by cryptsetup)
466 467 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
467 468 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
468 469 exit 1
469 470 fi
470 471
471 472 # Don't clobber an old build
472 473 if [ -e "$BUILDDIR" ] ; then
473 474 echo "error: directory ${BUILDDIR} already exists, not proceeding"
474 475 exit 1
475 476 fi
476 477
477 478 # Setup chroot directory
478 479 mkdir -p "${R}"
479 480
480 481 # Check if build directory has enough of free disk space >512MB
481 482 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
482 483 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
483 484 exit 1
484 485 fi
485 486
486 487 set -x
487 488
488 489 # Call "cleanup" function on various signals and errors
489 490 trap cleanup 0 1 2 3 6
490 491
491 492 # Add required packages for the minbase installation
492 493 if [ "$ENABLE_MINBASE" = true ] ; then
493 494 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
494 495 fi
495 496
496 497 # Add parted package, required to get partprobe utility
497 498 if [ "$EXPANDROOT" = true ] ; then
498 499 APT_INCLUDES="${APT_INCLUDES},parted"
499 500 fi
500 501
501 502 # Add dbus package, recommended if using systemd
502 503 if [ "$ENABLE_DBUS" = true ] ; then
503 504 APT_INCLUDES="${APT_INCLUDES},dbus"
504 505 fi
505 506
506 507 # Add iptables IPv4/IPv6 package
507 508 if [ "$ENABLE_IPTABLES" = true ] ; then
508 509 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
509 510 fi
510 511
511 512 # Add openssh server package
512 513 if [ "$ENABLE_SSHD" = true ] ; then
513 514 APT_INCLUDES="${APT_INCLUDES},openssh-server"
514 515 fi
515 516
516 517 # Add alsa-utils package
517 518 if [ "$ENABLE_SOUND" = true ] ; then
518 519 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
519 520 fi
520 521
521 522 # Add rng-tools package
522 523 if [ "$ENABLE_HWRANDOM" = true ] ; then
523 524 APT_INCLUDES="${APT_INCLUDES},rng-tools"
524 525 fi
525 526
526 527 # Add fbturbo video driver
527 528 if [ "$ENABLE_FBTURBO" = true ] ; then
528 529 # Enable xorg package dependencies
529 530 ENABLE_XORG=true
530 531 fi
531 532
532 533 # Add user defined window manager package
533 534 if [ -n "$ENABLE_WM" ] ; then
534 535 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
535 536
536 537 # Enable xorg package dependencies
537 538 ENABLE_XORG=true
538 539 fi
539 540
540 541 # Add xorg package
541 542 if [ "$ENABLE_XORG" = true ] ; then
542 543 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
543 544 fi
544 545
545 546 # Replace selected packages with smaller clones
546 547 if [ "$ENABLE_REDUCE" = true ] ; then
547 548 # Add levee package instead of vim-tiny
548 549 if [ "$REDUCE_VIM" = true ] ; then
549 550 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
550 551 fi
551 552
552 553 # Add dropbear package instead of openssh-server
553 554 if [ "$REDUCE_SSHD" = true ] ; then
554 555 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
555 556 fi
556 557 fi
557 558
558 559 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
559 560 if [ "$ENABLE_SYSVINIT" = false ] ; then
560 561 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
561 562 fi
562 563
563 564 # Configure kernel sources if no KERNELSRC_DIR
564 565 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
565 566 KERNELSRC_CONFIG=true
566 567 fi
567 568
568 569 # Configure reduced kernel
569 570 if [ "$KERNEL_REDUCE" = true ] ; then
570 571 KERNELSRC_CONFIG=false
571 572 fi
572 573
573 574 # Configure qemu compatible kernel
574 575 if [ "$ENABLE_QEMU" = true ] ; then
575 576 DTB_FILE=vexpress-v2p-ca15_a7.dtb
576 577 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
577 578 KERNEL_DEFCONFIG="vexpress_defconfig"
578 579 if [ "$KERNEL_MENUCONFIG" = false ] ; then
579 580 KERNEL_OLDDEFCONFIG=true
580 581 fi
581 582 fi
582 583
583 584 # Execute bootstrap scripts
584 585 for SCRIPT in bootstrap.d/*.sh; do
585 586 head -n 3 "$SCRIPT"
586 587 . "$SCRIPT"
587 588 done
588 589
589 590 ## Execute custom bootstrap scripts
590 591 if [ -d "custom.d" ] ; then
591 592 for SCRIPT in custom.d/*.sh; do
592 593 . "$SCRIPT"
593 594 done
594 595 fi
595 596
596 597 # Execute custom scripts inside the chroot
597 598 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
598 599 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
599 600 chroot_exec /bin/bash -x <<'EOF'
600 601 for SCRIPT in /chroot_scripts/* ; do
601 602 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
602 603 $SCRIPT
603 604 fi
604 605 done
605 606 EOF
606 607 rm -rf "${R}/chroot_scripts"
607 608 fi
608 609
609 610 # Remove c/c++ build environment from the chroot
610 611 chroot_remove_cc
611 612
612 613 # Generate required machine-id
613 614 MACHINE_ID=$(dbus-uuidgen)
614 615 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
615 616 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
616 617
617 618 # APT Cleanup
618 619 chroot_exec apt-get -y clean
619 620 chroot_exec apt-get -y autoclean
620 621 chroot_exec apt-get -y autoremove
621 622
622 623 # Unmount mounted filesystems
623 624 umount -l "${R}/proc"
624 625 umount -l "${R}/sys"
625 626
626 627 # Clean up directories
627 628 rm -rf "${R}/run/*"
628 629 rm -rf "${R}/tmp/*"
629 630
630 631 # Clean up files
631 632 rm -f "${ETC_DIR}/ssh/ssh_host_*"
632 633 rm -f "${ETC_DIR}/dropbear/dropbear_*"
633 634 rm -f "${ETC_DIR}/apt/sources.list.save"
634 635 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
635 636 rm -f "${ETC_DIR}/*-"
636 637 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
637 638 rm -f "${ETC_DIR}/resolv.conf"
638 639 rm -f "${R}/root/.bash_history"
639 640 rm -f "${R}/var/lib/urandom/random-seed"
640 641 rm -f "${R}/initrd.img"
641 642 rm -f "${R}/vmlinuz"
642 643 rm -f "${R}${QEMU_BINARY}"
643 644
644 645 if [ "$ENABLE_QEMU" = true ] ; then
645 646 # Setup QEMU directory
646 647 mkdir "${BASEDIR}/qemu"
647 648
648 649 # Copy kernel image to QEMU directory
649 650 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
650 651
651 652 # Copy kernel config to QEMU directory
652 653 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
653 654
654 655 # Copy kernel dtbs to QEMU directory
655 656 for dtb in "${BOOT_DIR}/"*.dtb ; do
656 657 if [ -f "${dtb}" ] ; then
657 658 install_readonly "${dtb}" "${BASEDIR}/qemu/"
658 659 fi
659 660 done
660 661
661 662 # Copy kernel overlays to QEMU directory
662 663 if [ -d "${BOOT_DIR}/overlays" ] ; then
663 664 # Setup overlays dtbs directory
664 665 mkdir "${BASEDIR}/qemu/overlays"
665 666
666 667 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
667 668 if [ -f "${dtb}" ] ; then
668 669 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
669 670 fi
670 671 done
671 672 fi
672 673
673 674 # Copy u-boot files to QEMU directory
674 675 if [ "$ENABLE_UBOOT" = true ] ; then
675 676 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
676 677 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
677 678 fi
678 679 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
679 680 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
680 681 fi
681 682 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
682 683 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
683 684 fi
684 685 fi
685 686
686 687 # Copy initramfs to QEMU directory
687 688 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
688 689 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
689 690 fi
690 691 fi
691 692
692 693 # Calculate size of the chroot directory in KB
693 694 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
694 695
695 696 # Calculate the amount of needed 512 Byte sectors
696 697 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
697 698 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
698 699 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
699 700
700 701 # The root partition is EXT4
701 702 # This means more space than the actual used space of the chroot is used.
702 703 # As overhead for journaling and reserved blocks 35% are added.
703 704 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
704 705
705 706 # Calculate required image size in 512 Byte sectors
706 707 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
707 708
708 709 # Prepare image file
709 710 if [ "$ENABLE_SPLITFS" = true ] ; then
710 711 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
711 712 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
712 713 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
713 714 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
714 715
715 716 # Write firmware/boot partition tables
716 717 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
717 718 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
718 719 EOM
719 720
720 721 # Write root partition table
721 722 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
722 723 ${TABLE_SECTORS},${ROOT_SECTORS},83
723 724 EOM
724 725
725 726 # Setup temporary loop devices
726 727 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
727 728 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
728 729 else # ENABLE_SPLITFS=false
729 730 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
730 731 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
731 732
732 733 # Write partition table
733 734 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
734 735 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
735 736 ${ROOT_OFFSET},${ROOT_SECTORS},83
736 737 EOM
737 738
738 739 # Setup temporary loop devices
739 740 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
740 741 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
741 742 fi
742 743
743 744 if [ "$ENABLE_CRYPTFS" = true ] ; then
744 745 # Create dummy ext4 fs
745 746 mkfs.ext4 "$ROOT_LOOP"
746 747
747 748 # Setup password keyfile
748 749 touch .password
749 750 chmod 600 .password
750 751 echo -n ${CRYPTFS_PASSWORD} > .password
751 752
752 753 # Initialize encrypted partition
753 754 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
754 755
755 756 # Open encrypted partition and setup mapping
756 757 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
757 758
758 759 # Secure delete password keyfile
759 760 shred -zu .password
760 761
761 762 # Update temporary loop device
762 763 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
763 764
764 765 # Wipe encrypted partition (encryption cipher is used for randomness)
765 766 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
766 767 fi
767 768
768 769 # Build filesystems
769 770 mkfs.vfat "$FRMW_LOOP"
770 771 mkfs.ext4 "$ROOT_LOOP"
771 772
772 773 # Mount the temporary loop devices
773 774 mkdir -p "$BUILDDIR/mount"
774 775 mount "$ROOT_LOOP" "$BUILDDIR/mount"
775 776
776 777 mkdir -p "$BUILDDIR/mount/boot/firmware"
777 778 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
778 779
779 780 # Copy all files from the chroot to the loop device mount point directory
780 781 rsync -a "${R}/" "$BUILDDIR/mount/"
781 782
782 783 # Unmount all temporary loop devices and mount points
783 784 cleanup
784 785
785 786 # Create block map file(s) of image(s)
786 787 if [ "$ENABLE_SPLITFS" = true ] ; then
787 788 # Create block map files for "bmaptool"
788 789 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
789 790 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
790 791
791 792 # Image was successfully created
792 793 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
793 794 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
794 795 else
795 796 # Create block map file for "bmaptool"
796 797 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
797 798
798 799 # Image was successfully created
799 800 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
800 801
801 802 # Create qemu qcow2 image
802 803 if [ "$ENABLE_QEMU" = true ] ; then
803 804 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
804 805 QEMU_SIZE=16G
805 806
806 807 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
807 808 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
808 809
809 810 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
810 811 fi
811 812 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant